import com.jkristian.io.ByteCopier;

import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;

public class ReadURLs
{
    /**
     * Copy headers and data from the given URLs to System.out. Supports p4
     * URLs, as well as any other URL schemes supported by Java or installed in
     * the JVM.
     * 
     * @see com.perforce.api.protocol.p4.Handler
     */
    public static void main(String[] URLs) throws Exception
    {
        com.perforce.api.protocol.p4.Handler.install(); // support p4 URLs
        for (int u = 0; u < URLs.length; ++u) {
            URL url = new URL(URLs[u]);
            URLConnection connection = url.openConnection();
            for (int h = 0; true; ++h) {
                String name = connection.getHeaderFieldKey(h);
                String value = connection.getHeaderField(h);
                if (value == null)
                    break;
                if (name == null)
                    System.out.println(value);
                else
                    System.out.println(name + ": " + value);
            }
            System.out.println();
            InputStream data = connection.getInputStream();
            try {
                ByteCopier.copyAll(data, System.out);
            } finally {
                data.close();
            }
            System.out.println();
            System.out.println("-------------------");
        }
    }

}
